;********************************************************************
; YAUS ( Yet Another Useless Stuff )
; YAUS is a very limited BASIC like interactive interpreter.
; Written by Zeroflag for the 512b "operating system" compo 2009.
; Do anything you want with the source code :)
;
; Build with FASM
;  fasm yaus.asm
;  Than copy the binary to the boot sector of your floppy disk
;  or the MBR of your hdd (At first save the original MBR ofcourse).
;********************************************************************

org $7C00

use16

     ; initialize 'heap mem'
     mov       di, lineIndex    ; heap memory is staring here
     mov       cx, di           ; length of heapmem
     xor       ax, ax

     mov       es, ax
     mov       ds, ax

     rep       stosb
     dec       ax
     stosb                 ; linenumbr = -1

     call      newLine

mainLoop:

     mov     si, [currentLine]

     mov     dx, si
     mov     bx, [lineIndex]
     cmp     si, bx

     mov     di, line
     jz      go

     ; currentLine index < lineIndex -> goto

     shl     si, 6          ; currentline*64
     add     si, lines
     mov     cx, 64
     rep     movsb          ; copy lines[currentLine] to line

     inc     dx
     mov     [currentLine], dx

     jmp     parseLine

go:

     ; getkey
     xor      ah, ah
     int      016h

     cmp      al, 8  ; backspace
     jnz      check1

     ;        delete last char,  di = line
     mov      cx, [chrIndex]
     dec      cx
     js       mainLoop
     mov      [chrIndex], cx

     jmp      writeOut

check1:

     cmp      al, 13 ; enter
     jnz      next

     xor      al, al     ; terminate string with 0
     call     storeChar

     ;        copy current line to lines
     mov      di, [lineIndex]
     mov      bx, di
     inc      bx
     mov      [lineIndex],   bx      ; increase lineIndex
     mov      [currentLine], bx
     shl      di, 6                  ; mul 64
     add      di, lines              ; store line into lines 'array'
     mov      si, line
     mov      cx, 64
     rep      movsb

parseLine:
     ; new line received
     ; parse line

     mov     si, line
     mov     al, [si+1]
     cmp     al, '='
     jz      assign
     cmp     al, '+'
     jz      assign
     cmp     al, '-'
     jz      assign
     jmp     skip2
assign:
     ; cmd assign
     push      ax              ; al = '='/'+'/-''
     xor       ah, ah
     ;mov       si, line

     lodsb
     add       ax, vars - 'a'
     mov       di, ax          ; left side index

     ; parse right side
     inc       si
     lodsb                     ; right side
     cmp       al, 'a'
     jae       var_assign

     dec       si              ; convert rigth side value to integer
     call      atoi
     mov       al, cl          ; al=right side vale
     jmp       do_assign

var_assign:
     xor       ah, ah
     add       ax, vars - 'a'
     mov       si, ax
     mov       al, [si]        ; al=right variable value

do_assign:
     mov       bl, [di]        ; bx=left  side value

     pop       cx
     cmp       cl, '='         ; constant assignment
     jz        sk3
sk1:
     cmp       cl, '+'         ; add right to left
     jnz       sk2
     add       al, bl
     jmp       sk3
sk2:                              ; sub rigth from left
     cmp       cl, '-'
     jnz       sk3
     sub       bl, al
     xchg      bl, al
sk3:
     stosb

     ; end of cmd assign
     jmp     continue

skip2:
     mov     di, print_cmd
     mov     cx, 4
     rep     cmpsb
     jnz     skip3

     ; cmd print
     mov     si, line + 6   ; length 'print' +1

     mov     bx, [si]                ; variable name
     mov     al, [bx + vars - 'a']   ; variable value

     call    itoa           ; cx = length
     mov     bp, di
     mov     dl, 40
     call    writeStr   ; writestr will return

     jmp     continue

skip3:
      mov    si, line
      mov    di, if_cmd

      mov    cx, 2
      rep    cmpsb

      jnz    skip4

      call   cmd_if
      or     cx, cx
      jz     continue  ; if false

      mov    si, line + 7  ; length 'if a=b'
      mov    di, line

cpy_line:                  ; copy from line+7 to line
      mov    dx, [si]
      movsb
      or     dx, dx
      jz     cycl_out      ; check dx
      jmp    cpy_line
cycl_out:

      jmp    parseLine


skip4:
      mov    si, line
      mov    di, goto_cmd
      mov    cx, 4
      rep    cmpsb
      jnz    skip5

      inc    si
      call   atoi             ; si is pointed to the line number
      sub    cx, 100          ; cx = line number
      mov    [currentLine], cx
      jmp    continue

skip5:
      ; unable to parse line
      mov    bp, if_cmd + 1 ; f - fault
      mov    cx, 1          ; length
      mov    dl, 40         ; column
      call   writeStr

continue:

     call    newLine
     jmp     mainLoop


next:
     call    storeChar
     ; rewrite the line
writeOut:
     mov     bp, line
     mov     dl, 4           ; column
     ;mov     cx, [chrIndex]  ; length (it is set by storechar)
     call    writeStr

     ; clear end of text
     mov      ax, $0920      ; mov      bl, ATTRIB  ;mov      cx, 1
     int      $10

     jmp      mainLoop


;*****************************************
; procedures
;*****************************************

; procedure writeStr: IN dl=column, bp=string, cx=len
writeStr:
      mov     ax, $1301
      mov     dh, [lineNumber]
;      cmp     dh, 25
;      ja      reset_row
;      jmp     reset_skip
;reset_row:
;      xor     dh, dh
;reset_skip:
      mov     bx, ATTRIB          ; color
      int     $10
      ret

; procedure newLine: no parameters
newLine:
        xor  ax, ax       ; reset index
        mov  [chrIndex], ax

        mov  al, [lineNumber] ; increase line number
        inc  al
        mov  [lineNumber], al

        add  al, 100
        call itoa               ; convert line number to ascii

        mov  bp, di             ; write prompt
        xor  dl, dl             ; column = 0, length is returned by itoa in cx
        ;mov  byte [ bp+3 ], ':' ; append :
        call writeStr
        ret

; procedure storeChar: IN al=char
storeChar:
     ; store character into puffer
     mov  cx, [chrIndex]
     mov  di, line
     add  di, cx
     stosb
     inc  cx
     mov  [chrIndex], cx
     ret

; procedure atoi: IN si=string; OUT cx=number
atoi:
      xor        ah, ah
      xor        cx, cx
      mov        bx, 10
atoi_loop:
      lodsb
      or         al, al
      jz         atoi_done

      xchg       cx, ax
      mul        bl
      xchg       cx, ax
      sub        ax, $30
      add        cx, ax

      jmp        atoi_loop
atoi_done:
      ret

; procedure itoa: IN al=number; OUT di=string, cx=length
itoa:
         std
         xor      ah, ah
         mov      di, end_output -1
         mov      cx, di
         mov      bl, 10
divcycl:
         div      bl        ; al result, ah remainder
         add      ah, $30
         xchg     al, ah
         stosb
         xchg     al, ah
         xor      ah, ah
         or       al, al
         jnz      divcycl
         sub      cx, di  ; length
         inc      di      ; str
         cld
         ret

; procedure cmd_if: OUT cx=true/false
cmd_if:
        xor       ah, ah
        mov       si, line +3     ; len if +1
        lodsb
        mov       di, vars - 'a'
        add       di, ax
        mov       bx, [di]          ; bl left side value

        lodsb     ; >,<,=
        mov       dx, ax          ; dl relation

        xor       ah, ah
        lodsb
        mov       di, vars - 'a'
        add       di, ax
        mov       ax, [di]        ; al right side value

        xor       cx, cx          ; clear return value
        cmp       dl, '>'
        jnz       r1
        cmp       bl, al          ; compare left and right side
        ja        true
        ret
r1:
        sub       dl, '<'         ; cmp       dl, '<'
        jnz       r2
        cmp       bl, al          ; compare left and right side
        jb        true
        ret
r2:
                                  ; cmp       dl, '=' ( ord('=')=61, ord('<')=60 )
        dec       dl
        jnz       r3
        cmp       bl, al          ; compare left and right side
        jz        true
r3:
        ret
true:
        inc       cx              ; cx=1 if true
        ret

ATTRIB            =   14

print_cmd         db 'print'
if_cmd            db 'if'
goto_cmd          db 'goto'

padding           db 0

; end of MBR
BOOT_END          db $55, $AA

; "heap" memory

lineIndex         =  3232         ; dw 0
currentLine       =  3234         ; dw 0
chrIndex          =  3236         ; dw 0

vars              =  3238         ; db 26 dup 0
line              =  3264         ; db 100 dup 0
end_output        =  3364         ; db 100 dup 0
lines             =  3464         ; db 3000 dup 0

lineNumber        =  6464         ; db 0